<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArtigoIdiomaERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfArtigoIdiomaERP
 * @subpackage Arrays
 */
class ArrayOfArtigoIdiomaERP extends AbstractStructArrayBase
{
    /**
     * The ArtigoIdiomaERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ArtigoIdiomaERP[]
     */
    public $ArtigoIdiomaERP;
    /**
     * Constructor method for ArrayOfArtigoIdiomaERP
     * @uses ArrayOfArtigoIdiomaERP::setArtigoIdiomaERP()
     * @param \StructType\ArtigoIdiomaERP[] $artigoIdiomaERP
     */
    public function __construct(array $artigoIdiomaERP = array())
    {
        $this
            ->setArtigoIdiomaERP($artigoIdiomaERP);
    }
    /**
     * Get ArtigoIdiomaERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ArtigoIdiomaERP[]|null
     */
    public function getArtigoIdiomaERP()
    {
        return isset($this->ArtigoIdiomaERP) ? $this->ArtigoIdiomaERP : null;
    }
    /**
     * Set ArtigoIdiomaERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ArtigoIdiomaERP[] $artigoIdiomaERP
     * @return \ArrayType\ArrayOfArtigoIdiomaERP
     */
    public function setArtigoIdiomaERP(array $artigoIdiomaERP = array())
    {
        foreach ($artigoIdiomaERP as $arrayOfArtigoIdiomaERPArtigoIdiomaERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfArtigoIdiomaERPArtigoIdiomaERPItem instanceof \StructType\ArtigoIdiomaERP) {
                throw new \InvalidArgumentException(sprintf('The ArtigoIdiomaERP property can only contain items of \StructType\ArtigoIdiomaERP, "%s" given', is_object($arrayOfArtigoIdiomaERPArtigoIdiomaERPItem) ? get_class($arrayOfArtigoIdiomaERPArtigoIdiomaERPItem) : gettype($arrayOfArtigoIdiomaERPArtigoIdiomaERPItem)), __LINE__);
            }
        }
        if (is_null($artigoIdiomaERP) || (is_array($artigoIdiomaERP) && empty($artigoIdiomaERP))) {
            unset($this->ArtigoIdiomaERP);
        } else {
            $this->ArtigoIdiomaERP = $artigoIdiomaERP;
        }
        return $this;
    }
    /**
     * Add item to ArtigoIdiomaERP value
     * @throws \InvalidArgumentException
     * @param \StructType\ArtigoIdiomaERP $item
     * @return \ArrayType\ArrayOfArtigoIdiomaERP
     */
    public function addToArtigoIdiomaERP(\StructType\ArtigoIdiomaERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ArtigoIdiomaERP) {
            throw new \InvalidArgumentException(sprintf('The ArtigoIdiomaERP property can only contain items of \StructType\ArtigoIdiomaERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ArtigoIdiomaERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ArtigoIdiomaERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ArtigoIdiomaERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ArtigoIdiomaERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ArtigoIdiomaERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ArtigoIdiomaERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArtigoIdiomaERP
     */
    public function getAttributeName()
    {
        return 'ArtigoIdiomaERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfArtigoIdiomaERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
